---
title: Scaling
slug: Games/Tutorials/2D_breakout_game_Phaser/Scaling
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Initialize_the_framework", "Games/Workflows/2D_Breakout_game_Phaser/Load_the_assets_and_print_them_on_screen")}}</p>

<div class="summary">
<p>This is the <strong>2nd step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson02.html">Gamedev-Phaser-Content-Kit/demos/lesson02.html</a>.</p>
</div>

<p><span class="seoSummary">Scaling refers to how the game canvas will scale on different screen sizes. We can make the game scale to fit on any screen size automatically during the preload stage, so we don't have to worry about it later.</span></p>

<h2 id="The_Phaser_scale_object">The Phaser scale object</h2>

<p>There's a special <code>scale</code> object available in Phaser with a few handy methods and properties available. Update your existing <code>preload()</code> function as follows:</p>

<pre class="brush: js notranslate">function preload() {
    game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
    game.scale.pageAlignHorizontally = true;
    game.scale.pageAlignVertically = true;
}
</pre>

<p><code>scaleMode</code> has a few different options available for how the Canvas can be scaled:</p>

<ul>
 <li><code>NO_SCALE</code> — nothing is scaled.</li>
 <li><code>EXACT_FIT</code> — scale the canvas to fill all the available space both vertically and horizontally, without preserving the aspect ratio.</li>
 <li><code>SHOW_ALL</code> — scales the canvas, but keeps the aspect ratio untouched, so images won't be skewed like in the previous mode. There might be black stripes visible on the edges of the screen, but we can live with that.</li>
 <li><code>RESIZE</code> — creates the canvas with the same size as the available width and height, so you have to place the objects inside your game dynamically; this is more of an advanced mode.</li>
 <li><code>USER_SCALE</code> — allows you to have custom dynamic scaling, calculating the size, scale and ratio on your own; again, this is more of an advanced mode</li>
</ul>

<p>The other two lines of code in the <code>preload()</code> function are responsible for aligning the canvas element horizontally and vertically, so it is always centered on screen regardless of size.</p>

<h2 id="Adding_a_custom_canvas_background_colour">Adding a custom canvas background colour</h2>

<p>We can also add a custom background color to our canvas, so it won't stay black. The <code>stage</code> object has a <code>backgroundColor</code> property for this purpose, which we can set using CSS color definition syntax. Add the following line below the other three you added earlier:</p>

<pre class="brush: js notranslate">game.stage.backgroundColor = '#eee';
</pre>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/6a64vecL/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Now we've set up the scaling for our game, let's continue to the third lesson and work out how to <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Load_the_assets_and_print_them_on_screen">load the assets and print them on screen</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Initialize_the_framework", "Games/Workflows/2D_Breakout_game_Phaser/Load_the_assets_and_print_them_on_screen")}}</p>
